// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

// Package gamelift provides the client and types for making API
// requests to Amazon GameLift.
//
// Amazon GameLift is a managed service for developers who need a scalable,
// dedicated server solution for their multiplayer games. Use Amazon GameLift
// for these tasks: (1) set up computing resources and deploy your game servers,
// (2) run game sessions and get players into games, (3) automatically scale
// your resources to meet player demand and manage costs, and (4) track in-depth
// metrics on game server performance and player usage.
//
// When setting up hosting resources, you can deploy your custom game server
// or use the Amazon GameLift Realtime Servers. Realtime Servers gives you the
// ability to quickly stand up lightweight, efficient game servers with the
// core Amazon GameLift infrastructure already built in.
//
// Get Amazon GameLift Tools and Resources
//
// This reference guide describes the low-level service API for Amazon GameLift
// and provides links to language-specific SDK reference topics. See also  Amazon
// GameLift Tools and Resources (https://docs.aws.amazon.com/gamelift/latest/developerguide/gamelift-components.html).
//
// API Summary
//
// The Amazon GameLift service API includes two key sets of actions:
//
//    * Manage game sessions and player access -- Integrate this functionality
//    into game client services in order to create new game sessions, retrieve
//    information on existing game sessions; reserve a player slot in a game
//    session, request matchmaking, etc.
//
//    * Configure and manage game server resources -- Manage your Amazon GameLift
//    hosting resources, including builds, scripts, fleets, queues, and aliases.
//    Set up matchmakers, configure auto-scaling, retrieve game logs, and get
//    hosting and game metrics.
//
// Task-based list of API actions (https://docs.aws.amazon.com/gamelift/latest/developerguide/reference-awssdk.html)
//
// See https://docs.aws.amazon.com/goto/WebAPI/gamelift-2015-10-01 for more information on this service.
//
// See gamelift package documentation for more information.
// https://docs.aws.amazon.com/sdk-for-go/api/service/gamelift/
//
// Using the Client
//
// To contact Amazon GameLift with the SDK use the New function to create
// a new service client. With that client you can make API requests to the service.
// These clients are safe to use concurrently.
//
// See the SDK's documentation for more information on how to use the SDK.
// https://docs.aws.amazon.com/sdk-for-go/api/
//
// See aws.Config documentation for more information on configuring SDK clients.
// https://docs.aws.amazon.com/sdk-for-go/api/aws/#Config
//
// See the Amazon GameLift client GameLift for more
// information on creating client for this service.
// https://docs.aws.amazon.com/sdk-for-go/api/service/gamelift/#New
package gamelift
