// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

// Package ram provides the client and types for making API
// requests to AWS Resource Access Manager.
//
// Use AWS Resource Access Manager to share AWS resources between AWS accounts.
// To share a resource, you create a resource share, associate the resource
// with the resource share, and specify the principals that can access the resource.
// The following principals are supported:
//
//    * The ID of an AWS account
//
//    * The Amazon Resource Name (ARN) of an OU from AWS Organizations
//
//    * The Amazon Resource Name (ARN) of an organization from AWS Organizations
//
// If you specify an AWS account that doesn't exist in the same organization
// as the account that owns the resource share, the owner of the specified account
// receives an invitation to accept the resource share. After the owner accepts
// the invitation, they can access the resources in the resource share. An administrator
// of the specified account can use IAM policies to restrict access resources
// in the resource share.
//
// See https://docs.aws.amazon.com/goto/WebAPI/ram-2018-01-04 for more information on this service.
//
// See ram package documentation for more information.
// https://docs.aws.amazon.com/sdk-for-go/api/service/ram/
//
// Using the Client
//
// To contact AWS Resource Access Manager with the SDK use the New function to create
// a new service client. With that client you can make API requests to the service.
// These clients are safe to use concurrently.
//
// See the SDK's documentation for more information on how to use the SDK.
// https://docs.aws.amazon.com/sdk-for-go/api/
//
// See aws.Config documentation for more information on configuring SDK clients.
// https://docs.aws.amazon.com/sdk-for-go/api/aws/#Config
//
// See the AWS Resource Access Manager client RAM for more
// information on creating client for this service.
// https://docs.aws.amazon.com/sdk-for-go/api/service/ram/#New
package ram
