// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

// Package redshift provides the client and types for making API
// requests to Amazon Redshift.
//
// Overview
//
// This is an interface reference for Amazon Redshift. It contains documentation
// for one of the programming or command line interfaces you can use to manage
// Amazon Redshift clusters. Note that Amazon Redshift is asynchronous, which
// means that some interfaces may require techniques, such as polling or asynchronous
// callback handlers, to determine when a command has been applied. In this
// reference, the parameter descriptions indicate whether a change is applied
// immediately, on the next instance reboot, or during the next maintenance
// window. For a summary of the Amazon Redshift cluster management interfaces,
// go to Using the Amazon Redshift Management Interfaces (https://docs.aws.amazon.com/redshift/latest/mgmt/using-aws-sdk.html).
//
// Amazon Redshift manages all the work of setting up, operating, and scaling
// a data warehouse: provisioning capacity, monitoring and backing up the cluster,
// and applying patches and upgrades to the Amazon Redshift engine. You can
// focus on using your data to acquire new insights for your business and customers.
//
// If you are a first-time user of Amazon Redshift, we recommend that you begin
// by reading the Amazon Redshift Getting Started Guide (https://docs.aws.amazon.com/redshift/latest/gsg/getting-started.html).
//
// If you are a database developer, the Amazon Redshift Database Developer Guide
// (https://docs.aws.amazon.com/redshift/latest/dg/welcome.html) explains how
// to design, build, query, and maintain the databases that make up your data
// warehouse.
//
// See https://docs.aws.amazon.com/goto/WebAPI/redshift-2012-12-01 for more information on this service.
//
// See redshift package documentation for more information.
// https://docs.aws.amazon.com/sdk-for-go/api/service/redshift/
//
// Using the Client
//
// To contact Amazon Redshift with the SDK use the New function to create
// a new service client. With that client you can make API requests to the service.
// These clients are safe to use concurrently.
//
// See the SDK's documentation for more information on how to use the SDK.
// https://docs.aws.amazon.com/sdk-for-go/api/
//
// See aws.Config documentation for more information on configuring SDK clients.
// https://docs.aws.amazon.com/sdk-for-go/api/aws/#Config
//
// See the Amazon Redshift client Redshift for more
// information on creating client for this service.
// https://docs.aws.amazon.com/sdk-for-go/api/service/redshift/#New
package redshift
