// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

// Package route53resolver provides the client and types for making API
// requests to Amazon Route 53 Resolver.
//
// Here's how you set up to query an Amazon Route 53 private hosted zone from
// your network:
//
// Connect your network to a VPC using AWS Direct Connect or a VPN.
//
// Run the following AWS CLI command to create a Resolver endpoint:
//
// create-resolver-endpoint --name [endpoint_name] --direction INBOUND --creator-request-id
// [unique_string] --security-group-ids [security_group_with_inbound_rules]
// --ip-addresses SubnetId=[subnet_id] SubnetId=[subnet_id_in_different_AZ]
//
// Note the resolver endpoint ID that appears in the response. You'll use it
// in step 3.
//
// Get the IP addresses for the Resolver endpoints:
//
// get-resolver-endpoint --resolver-endpoint-id [resolver_endpoint_id]
//
// In your network configuration, define the IP addresses that you got in step
// 3 as DNS servers.
//
// You can now query instance names in your VPCs and the names of records in
// your private hosted zone.
//
// You can also perform the following operations using the AWS CLI:
//
//    * list-resolver-endpoints: List all endpoints. The syntax includes options
//    for pagination and filtering.
//
//    * update-resolver-endpoints: Add IP addresses to an endpoint or remove
//    IP addresses from an endpoint.
//
// To delete an endpoint, use the following AWS CLI command:
//
// delete-resolver-endpoint --resolver-endpoint-id [resolver_endpoint_id]
//
// See https://docs.aws.amazon.com/goto/WebAPI/route53resolver-2018-04-01 for more information on this service.
//
// See route53resolver package documentation for more information.
// https://docs.aws.amazon.com/sdk-for-go/api/service/route53resolver/
//
// Using the Client
//
// To contact Amazon Route 53 Resolver with the SDK use the New function to create
// a new service client. With that client you can make API requests to the service.
// These clients are safe to use concurrently.
//
// See the SDK's documentation for more information on how to use the SDK.
// https://docs.aws.amazon.com/sdk-for-go/api/
//
// See aws.Config documentation for more information on configuring SDK clients.
// https://docs.aws.amazon.com/sdk-for-go/api/aws/#Config
//
// See the Amazon Route 53 Resolver client Route53Resolver for more
// information on creating client for this service.
// https://docs.aws.amazon.com/sdk-for-go/api/service/route53resolver/#New
package route53resolver
